diff --git a/src/main/java/net/minecraft/client/render/WorldRenderer.java b/src/main/java/net/minecraft/client/render/WorldRenderer.java
index eccac0135..ca54ffae0 100644
--- a/src/main/java/net/minecraft/client/render/WorldRenderer.java
+++ b/src/main/java/net/minecraft/client/render/WorldRenderer.java
@@ -5,6 +5,7 @@ import static org.lwjgl.opengl.GL11.*;
 import java.util.List;
 import java.util.Random;
 
+import net.minecraft.client.world.chunk.provider.ChunkProviderDynamic;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.util.phys.Vec3;
 import org.lwjgl.input.Mouse;
@@ -20,6 +21,7 @@ import net.minecraft.client.gui.modelviewer.GuiModelViewer;
 import net.minecraft.client.input.InputType;
 import net.minecraft.client.input.MouseFilter;
 import net.minecraft.client.input.PlayerInput;
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.camera.CameraUtil;
 import net.minecraft.client.render.camera.EntityCamera;
 import net.minecraft.client.render.camera.EntityCameraFirstPerson;
@@ -32,7 +34,6 @@ import net.minecraft.client.render.culling.Frustum;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.util.debug.Debug;
-import net.minecraft.client.world.chunk.provider.ChunkProviderStatic;
 import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.material.Material;
@@ -579,7 +580,7 @@ public class WorldRenderer
         }
     }
 
-    public void renderWorld(float partialTick, long updateRenderersUntil)
+    public void renderWorld(float partialTicks, long updateRenderersUntil)
     {
     	Debug.push("misc");
         Colorizers.update(false);
@@ -593,7 +594,7 @@ public class WorldRenderer
         {
             mc.activeCamera = new EntityCameraFirstPerson(mc, mc.thePlayer);
         }
-        getMouseOver(partialTick);
+        getMouseOver(partialTicks);
         Mob activeEntity = null;
         if (mc.activeCamera instanceof EntityCamera)
         {
@@ -602,70 +603,76 @@ public class WorldRenderer
 
         if (activeEntity != null)
         {
-            double viewEntityX = activeEntity.xo + (activeEntity.x - activeEntity.xo) * (double)partialTick;
-            double viewEntityZ = activeEntity.zo + (activeEntity.z - activeEntity.zo) * (double)partialTick;
+            double viewEntityX = activeEntity.xo + (activeEntity.x - activeEntity.xo) * (double)partialTicks;
+            double viewEntityZ = activeEntity.zo + (activeEntity.z - activeEntity.zo) * (double)partialTicks;
             IChunkProvider iChunkProvider = mc.theWorld.getChunkProvider();
-            if(iChunkProvider instanceof ChunkProviderStatic)
+            if(iChunkProvider instanceof ChunkProviderDynamic)
             {
-                ChunkProviderStatic chunkProviderStatic = (ChunkProviderStatic)iChunkProvider;
+                ChunkProviderDynamic ChunkProviderDynamic = (ChunkProviderDynamic)iChunkProvider;
                 int chunkX = MathHelper.floor_float((int)viewEntityX) >> 4;
                 int chunkZ = MathHelper.floor_float((int)viewEntityZ) >> 4;
-                chunkProviderStatic.setCurrentChunkOver(chunkX, chunkZ);
+                ChunkProviderDynamic.setCurrentChunkOver(chunkX, chunkZ);
             }
         }
 
-        fogManager.updateFogColor(partialTick);
+        fogManager.updateFogColor(partialTicks);
         
         Debug.change("post");
-        mc.renderer.beginRenderWorld(partialTick);
+        mc.renderer.beginRenderWorld(partialTicks);
         glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
         glEnable(GL_CULL_FACE);
-        setupCameraTransform(partialTick);
+        setupCameraTransform(partialTicks);
         Frustum.getFrustum();
         Debug.change("sky");
         if(mc.gameSettings.renderDistance.value.renderSky && !(mc.currentScreen instanceof GuiModelViewer))
         {
-            fogManager.setupFog(FogManager.FOG_MODE_SKY, farPlaneDistance, partialTick);
+            fogManager.setupFog(FogManager.FOG_MODE_SKY, farPlaneDistance, partialTicks);
             glDisable(GL_FOG);
 
-            renderGlobal.drawSky(partialTick);
+            renderGlobal.drawSky(partialTicks);
         }
         
         Debug.change("misc");
         glEnable(GL_FOG);
-        fogManager.setupFog(FogManager.FOG_MODE_NORMAL, farPlaneDistance, partialTick);
+        fogManager.setupFog(FogManager.FOG_MODE_NORMAL, farPlaneDistance, partialTicks);
         if(mc.gameSettings.ambientOcclusion.value)
         {
             glShadeModel(GL11.GL_SMOOTH);
         }
         
-        mc.renderGlobal.clipRenderersByFrustum(mc.activeCamera.getFrustum(), partialTick);
+        mc.renderGlobal.clipRenderersByFrustum(mc.activeCamera.getFrustum(), partialTicks);
 
         Debug.change("aurora");
         if (mc.gameSettings.aurora.value && mc.theWorld.getWorldType().hasAurora())
         {
-            renderGlobal.renderAurora(mc.activeCamera, partialTick);
+            renderGlobal.renderAurora(mc.activeCamera, partialTicks);
         }
         Debug.change("update");
 
-        long l1;
-        do
-        {
-            if(mc.renderGlobal.updateRenderers(mc.activeCamera) || updateRenderersUntil == 0L)
+        int loops = 1;
+        if(mc.gameSettings.keyLoadChunksQuickly.isPressed()) {
+        	loops = 40;
+        }
+        for(int i=0; i < loops; i++) {
+            long l1;
+            do
             {
-                break;
-            }
-            l1 = updateRenderersUntil - System.nanoTime();
-        } while(l1 >= 0L && l1 <= nsPerSecond);
+                if(mc.renderGlobal.updateRenderers(mc.activeCamera) || updateRenderersUntil == 0L)
+                {
+                    break;
+                }
+                l1 = updateRenderersUntil - System.nanoTime();
+            } while(l1 >= 0L && l1 <= nsPerSecond);
+        }
 
-        fogManager.setupFog(FogManager.FOG_MODE_NORMAL, farPlaneDistance, partialTick);
+        fogManager.setupFog(FogManager.FOG_MODE_NORMAL, farPlaneDistance, partialTicks);
         glEnable(GL_FOG);
         TextureRegistry.blockAtlas.bind();
         Lighting.disable();
 
         Debug.change("terrain");
         lightmapHelper.enableLightmapRendering();
-        renderGlobal.sortAndRender(mc.activeCamera, 0, partialTick);
+        mc.terrainRenderer.renderSolidTerrain(partialTicks);
 
         Debug.change("entities");
         glShadeModel(GL_FLAT);
@@ -675,17 +682,17 @@ public class WorldRenderer
         {
             glDisable(GL_FOG);
         }
-        renderGlobal.renderEntities(mc.activeCamera, partialTick);
+        renderGlobal.renderEntities(mc.activeCamera, partialTicks);
         if (!mc.gameSettings.fog.value)
         {
             glEnable(GL_FOG);
         }
         
         Debug.change("particles");
-        effectRenderer.renderParticlesAtOrigin(partialTick);
+        effectRenderer.renderParticlesAtOrigin(partialTicks);
         Lighting.disable();
-        fogManager.setupFog(FogManager.FOG_MODE_NORMAL, farPlaneDistance, partialTick);
-        effectRenderer.renderParticles(mc.activeCamera, partialTick);
+        fogManager.setupFog(FogManager.FOG_MODE_NORMAL, farPlaneDistance, partialTicks);
+        effectRenderer.renderParticles(mc.activeCamera, partialTicks);
 
         lightmapHelper.disableLightmapRendering();
         
@@ -693,76 +700,58 @@ public class WorldRenderer
         if(mc.objectMouseOver != null)
         {
             glDisable(GL_ALPHA_TEST);
-            renderGlobal.drawBlockBreaking(mc.activeCamera, mc.objectMouseOver, partialTick);
-            renderGlobal.drawSelectionBox(mc.activeCamera, mc.objectMouseOver, partialTick);
+            renderGlobal.drawBlockBreaking(mc.activeCamera, mc.objectMouseOver, partialTicks);
+            renderGlobal.drawSelectionBox(mc.activeCamera, mc.objectMouseOver, partialTicks);
             glEnable(GL_ALPHA_TEST);
         }
         
         Debug.change("debugoverlays");
         if(mc.gameSettings.showCollisionBoxes.value)
         {
-        	renderGlobal.drawDebugEntityOutlines(mc.activeCamera, partialTick);
+        	renderGlobal.drawDebugEntityOutlines(mc.activeCamera, partialTicks);
         }
         if(mc.gameSettings.showChunkBorders.value)
         {
-        	renderGlobal.drawDebugChunkBorders(mc.activeCamera, partialTick);
+        	renderGlobal.drawDebugChunkBorders(mc.activeCamera, partialTicks);
         }
         glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
-        fogManager.setupFog(FogManager.FOG_MODE_NORMAL, farPlaneDistance, partialTick);
+        fogManager.setupFog(FogManager.FOG_MODE_NORMAL, farPlaneDistance, partialTicks);
         glEnable(GL_BLEND);
         glDisable(GL_CULL_FACE);
         TextureRegistry.blockAtlas.bind();
 
         Debug.change("water");
-        if(mc.gameSettings.ambientOcclusion.value)
-        {
-            glShadeModel(GL_SMOOTH);
-        }
-        if(mc.gameSettings.fancyGraphics.value == 1)
-        {
-            glColorMask(false, false, false, false);
-            int i1 = renderGlobal.sortAndRender(mc.activeCamera, 1, partialTick);
-            glColorMask(true, true, true, true);
-            if(i1 > 0)
-            {
-                lightmapHelper.enableLightmapRendering();
-                if (!mc.gameSettings.fog.value)
-                {
-                    glDisable(GL_FOG);
-                }
-                renderGlobal.callAllDisplayLists(1, partialTick);
-                if (!mc.gameSettings.fog.value)
-                {
-                    glEnable(GL_FOG);
-                }
-                lightmapHelper.disableLightmapRendering();
-            }
-        }
-        else
-        {
-        	lightmapHelper.enableLightmapRendering();
-            renderGlobal.sortAndRender(mc.activeCamera, 1, partialTick);
-            lightmapHelper.disableLightmapRendering();
-        }
-        glShadeModel(GL_FLAT);
+		lightmapHelper.enableLightmapRendering();
+		if(mc.gameSettings.ambientOcclusion.value) {
+			glShadeModel(GL_SMOOTH);
+		}
+		if(!mc.gameSettings.fog.value) {
+			glDisable(GL_FOG);
+		}
+        mc.terrainRenderer.renderTranslucentTerrain(partialTicks);
+		if(!mc.gameSettings.fog.value) {
+			glEnable(GL_FOG);
+		}
+		glShadeModel(GL_FLAT);
+		lightmapHelper.disableLightmapRendering();
         
         Debug.change("weather");
         glDepthMask(true);
         glEnable(GL_CULL_FACE);
         glDisable(GL_BLEND);
-        renderRainSnow(partialTick);
+        renderRainSnow(partialTicks);
         glDisable(GL_FOG);
         if(mc.gameSettings.clouds.value) {
         	Debug.change("clouds");
-            fogManager.setupFog(FogManager.FOG_MODE_NORMAL, farPlaneDistance, partialTick);
+            fogManager.setupFog(FogManager.FOG_MODE_NORMAL, farPlaneDistance, partialTicks);
             glEnable(GL_FOG);
-            renderGlobal.renderClouds(partialTick);
+            renderGlobal.renderClouds(partialTicks);
             glDisable(GL_FOG);
         }
 
         Debug.change("misc");
-        fogManager.setupFog(1, farPlaneDistance, partialTick);
-        renderHand(partialTick);
+        fogManager.setupFog(1, farPlaneDistance, partialTicks);
+        renderHand(partialTicks);
         
         glColorMask(true, true, true, true);
         Debug.pop();
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index 342f51d47..cadad76b5 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -361,10 +361,10 @@ public class BlockModelDispatcher
 
         addDispatch(new StandardBlockModel<>(Blocks.WORKBENCH).withTextures("minecraft:block/workbench_top", "minecraft:block/planks_oak", "minecraft:block/workbench_front", "minecraft:block/workbench_side", "minecraft:block/workbench_front", "minecraft:block/workbench_side"));
 
-        addDispatch(new HorizontalRotationBlockModel<>(Blocks.FURNACE_STONE_IDLE).withTextures("minecraft:block/furnace_stone_top", "minecraft:block/furnace_stone_top", "minecraft:block/furnace_stone_idle_front", "minecraft:block/furnace_stone_side", "minecraft:block/furnace_stone_side", "minecraft:block/furnace_stone_side"));
-        addDispatch(new HorizontalRotationBlockModel<>(Blocks.FURNACE_STONE_ACTIVE).withTextures("minecraft:block/furnace_stone_top", "minecraft:block/furnace_stone_top", "minecraft:block/furnace_stone_active_front", "minecraft:block/furnace_stone_side", "minecraft:block/furnace_stone_side", "minecraft:block/furnace_stone_side"));
-        addDispatch(new HorizontalRotationBlockModel<>(Blocks.FURNACE_BLAST_IDLE).withTextures("minecraft:block/furnace_blast_top", "minecraft:block/furnace_blast_bottom", "minecraft:block/furnace_blast_idle_front", "minecraft:block/furnace_blast_side", "minecraft:block/furnace_blast_side", "minecraft:block/furnace_blast_side"));
-        addDispatch(new HorizontalRotationBlockModel<>(Blocks.FURNACE_BLAST_ACTIVE).withTextures("minecraft:block/furnace_blast_top", "minecraft:block/furnace_blast_bottom", "minecraft:block/furnace_blast_active_front", "minecraft:block/furnace_blast_side", "minecraft:block/furnace_blast_side", "minecraft:block/furnace_blast_side"));
+        addDispatch(new FurnaceBlockModel<>(Blocks.FURNACE_STONE_IDLE).withTextures("minecraft:block/furnace_stone_top", "minecraft:block/furnace_stone_top", "minecraft:block/furnace_stone_idle_front", "minecraft:block/furnace_stone_side", "minecraft:block/furnace_stone_side", "minecraft:block/furnace_stone_side"));
+        addDispatch(new FurnaceBlockModel<>(Blocks.FURNACE_STONE_ACTIVE).withTextures("minecraft:block/furnace_stone_top", "minecraft:block/furnace_stone_top", "minecraft:block/furnace_stone_active_front", "minecraft:block/furnace_stone_side", "minecraft:block/furnace_stone_side", "minecraft:block/furnace_stone_side"));
+        addDispatch(new FurnaceBlockModel<>(Blocks.FURNACE_BLAST_IDLE).withTextures("minecraft:block/furnace_blast_top", "minecraft:block/furnace_blast_bottom", "minecraft:block/furnace_blast_idle_front", "minecraft:block/furnace_blast_side", "minecraft:block/furnace_blast_side", "minecraft:block/furnace_blast_side"));
+        addDispatch(new FurnaceBlockModel<>(Blocks.FURNACE_BLAST_ACTIVE).withTextures("minecraft:block/furnace_blast_top", "minecraft:block/furnace_blast_bottom", "minecraft:block/furnace_blast_active_front", "minecraft:block/furnace_blast_side", "minecraft:block/furnace_blast_side", "minecraft:block/furnace_blast_side"));
 
         addDispatch(new HorizontalRotationBlockModel<>(Blocks.TROMMEL_IDLE).withTextures("minecraft:block/trommel_top", "minecraft:block/trommel_top", "minecraft:block/trommel_idle_front", "minecraft:block/trommel_side_slot", "minecraft:block/trommel_idle_front", "minecraft:block/trommel_side"));
         addDispatch(new HorizontalRotationBlockModel<>(Blocks.TROMMEL_ACTIVE).withTextures("minecraft:block/trommel_top", "minecraft:block/trommel_top", "minecraft:block/trommel_active_front", "minecraft:block/trommel_side_slot", "minecraft:block/trommel_active_back", "minecraft:block/trommel_side"));
diff --git a/src/main/java/net/minecraft/client/render/block/model/FurnaceBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/FurnaceBlockModel.java
new file mode 100644
index 000000000..0324d511e
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/block/model/FurnaceBlockModel.java
@@ -0,0 +1,37 @@
+package net.minecraft.client.render.block.model;
+
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.player.inventory.container.Container;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.helper.Sides;
+import net.minecraft.core.world.WorldSource;
+
+public class FurnaceBlockModel<T extends Block>
+    extends HorizontalRotationBlockModel<T> {
+
+    public FurnaceBlockModel(Block block) {
+        super(block);
+    }
+
+    @Override
+    public IconCoordinate getBlockTexture(WorldSource blockAccess, int x, int y, int z, Side side) {
+        int data = blockAccess.getBlockMetadata(x, y, z);
+        int index = Sides.orientationLookUpHorizontal[6 * Math.min(data, 5) + side.getId()];
+        if (index >= Sides.orientationLookUpHorizontal.length) return atlasIndices[0];
+        if (index == Side.NORTH.getId()) {
+            IconCoordinate originalFront = atlasIndices[index];
+            Container container = (Container) blockAccess.getBlockEntity(x, y, z);
+            if (container != null) {
+                boolean hasOutput = container.getItem(2) != null;
+                if (hasOutput) {
+                    IconCoordinate newFront = TextureRegistry.getTexture(originalFront.namespaceId.namespace + ":block/" + originalFront.namespaceId.value + "_filled");
+                    return newFront;
+                }
+            }
+            return originalFront;
+        }
+        return atlasIndices[index];
+    }
+}
diff --git a/src/main/java/net/minecraft/client/render/colorizer/Colorizer.java b/src/main/java/net/minecraft/client/render/colorizer/Colorizer.java
index 70a2fa749..f5c469ca0 100644
--- a/src/main/java/net/minecraft/client/render/colorizer/Colorizer.java
+++ b/src/main/java/net/minecraft/client/render/colorizer/Colorizer.java
@@ -9,6 +9,8 @@ import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.season.Season;
 import net.minecraft.core.world.season.Seasons;
+import net.minecraft.core.world.type.WorldType;
+import net.minecraft.core.world.type.WorldTypes;
 
 public class Colorizer {
 	
@@ -29,12 +31,26 @@ public class Colorizer {
 		}
 		
 		String path = null;
+
+		// First, check for worldtype overrides
+		WorldType worldType = minecraft.theWorld.worldType;
+		if(worldType == WorldTypes.OVERWORLD_HELL) {
+			path = "/assets/minecraft/textures/colormap/" + this.name + "/hell.png";
+			texturePack = Colorizers.findTexturePackWithFile(minecraft, path);
+		}
+		if(worldType == WorldTypes.OVERWORLD_WINTER) {
+			path = "/assets/minecraft/textures/colormap/" + this.name + "/winter.png";
+			texturePack = Colorizers.findTexturePackWithFile(minecraft, path);
+		}
+		
+		if(texturePack == null) {
+			// Check if there is a colormap for the current dimension
+			Dimension dimension = minecraft.theWorld.dimension;
+			String dimensionName = dimension.languageKey.replace('.', '_').toLowerCase();
+			path = "/assets/minecraft/textures/colormap/" + this.name + "/" + dimensionName + ".png";
+			texturePack = Colorizers.findTexturePackWithFile(minecraft, path);	
+		}
 		
-		// First, check if there is a colormap for the current dimension
-		Dimension dimension = minecraft.theWorld.dimension;
-		String dimensionName = dimension.languageKey.replace('.', '_').toLowerCase();
-		path = "/assets/minecraft/textures/colormap/" + this.name + "/" + dimensionName + ".png";
-		texturePack = Colorizers.findTexturePackWithFile(minecraft, path);
 		
 		if(texturePack == null) {
 			// If there is no colormap for the currrent dimension, check if there is a default colormap, to be used for all dimensions
@@ -60,19 +76,15 @@ public class Colorizer {
 		if(season == null || season == Seasons.NULL) {
 			return defaultColor;
 		}
-//		System.out.println("Loading colormap "+this.name+": dimension: " + dimension.languageKey + " season: " + season.getId());
 		
 		String seasonName = season.getId().replace('.', '_').toLowerCase();
 		String seasonPath = "/assets/minecraft/textures/colormap/" + this.name + "/" + seasonName + ".png";
 		
 		ColorMap seasonColor = Colorizers.loadColorData(texturePack, seasonPath);
-//		System.out.println(seasonPath + ": " + seasonColor);
 		if(seasonColor != null) {
-//			System.out.println("  Using season colors!");
 			return seasonColor;
 		}
 		
-//		System.out.println("  Using default colors!");
 		return defaultColor;
 	}
 	
diff --git a/src/main/java/net/minecraft/client/render/item/model/StandardItemModel.java b/src/main/java/net/minecraft/client/render/item/model/StandardItemModel.java
index 56d46e723..ff5bf5749 100644
--- a/src/main/java/net/minecraft/client/render/item/model/StandardItemModel.java
+++ b/src/main/java/net/minecraft/client/render/item/model/StandardItemModel.java
@@ -210,6 +210,11 @@ public class StandardItemModel extends ItemModel{
         }  else {
             GL11.glColor4f(brightness, brightness, brightness, 1.0F);
         }
+        if(LightmapHelper.isLightmapEnabled() && itemfullBright && entity != null) {
+        	int lmc = entity.getLightmapCoord(1.0f);
+        	lmc = LightmapHelper.setBlocklightValue(lmc, 15);
+        	LightmapHelper.setLightmapCoord(lmc);
+        }
         if(mc.gameSettings.items3D.value) {
             glPushMatrix();
 
diff --git a/src/main/java/net/minecraft/client/render/terrain/ChunkRenderer.java b/src/main/java/net/minecraft/client/render/terrain/ChunkRenderer.java
new file mode 100644
index 000000000..2b2cfd8b1
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/terrain/ChunkRenderer.java
@@ -0,0 +1,194 @@
+package net.minecraft.client.render.terrain;
+
+import java.util.ArrayList;
+import java.util.List;
+
+import org.lwjgl.opengl.GL11;
+
+import net.minecraft.client.render.RenderBlocks;
+import net.minecraft.client.render.block.model.BlockModel;
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.camera.ICamera;
+import net.minecraft.client.render.culling.CameraFrustum;
+import net.minecraft.client.render.entity.ItemEntityRenderer;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.World;
+
+public abstract class ChunkRenderer
+{
+    public static final int MAX_RENDER_PASSES = 2;
+    public static int updates = 0;
+    
+    public World world;
+    protected final int lists;
+    public int posX;
+    public int posY;
+    public int posZ;
+    public int sizeX;
+    public int sizeY;
+    public int sizeZ;
+    public int xRender;
+    public int yRender;
+    public int zRender;
+    public int xRenderOffs;
+    public int yRenderOffs;
+    public int zRenderOffs;
+    public boolean visible;
+    public boolean[] empty;
+    public int xm;
+    public int ym;
+    public int zm;
+    public float radius;
+    public boolean dirty;
+    public AABB bb;
+    public int id;
+    public boolean occlusionVisible;
+    public boolean occlusionQuerying;
+    public int occlusionId;
+    public boolean skyLit;
+    protected boolean compiled;
+    public List<BlockEntity> renderableBlockEntities;
+    protected final List<BlockEntity> globalRenderableBlockEntities;
+
+    public ChunkRenderer(World world, List<BlockEntity> globalRenderableTileEntities, int x, int y, int z, int size, int lists)
+    {
+        visible = false;
+        empty = new boolean[MAX_RENDER_PASSES];
+        occlusionVisible = true;
+        compiled = false;
+        renderableBlockEntities = new ArrayList<>();
+        this.world = world;
+        globalRenderableBlockEntities = globalRenderableTileEntities;
+        sizeX = sizeY = sizeZ = size;
+        radius = MathHelper.sqrt_float(sizeX * sizeX + sizeY * sizeY + sizeZ * sizeZ) / 2.0F;
+        this.lists = lists;
+        this.posX = -999;
+        setPos(x, y, z);
+        dirty = false;
+    }
+
+    public void setPos(int x, int y, int z)
+    {
+        if (x != this.posX || y != this.posY || z != this.posZ)
+        {
+            reset();
+            this.posX = x;
+            this.posY = y;
+            this.posZ = z;
+            xm = x + sizeX / 2;
+            ym = y + sizeY / 2;
+            zm = z + sizeZ / 2;
+            xRenderOffs = x & 0x3ff;
+            yRenderOffs = y;
+            zRenderOffs = z & 0x3ff;
+            xRender = x - xRenderOffs;
+            yRender = y - yRenderOffs;
+            zRender = z - zRenderOffs;
+            float f = 6F;
+            bb = AABB.getPermanentBB((float)x - f, (float)y - f, (float)z - f, (float)(x + sizeX) + f, (float)(y + sizeY) + f, (float)(z + sizeZ) + f);
+            GL11.glNewList(lists + MAX_RENDER_PASSES, GL11.GL_COMPILE);
+            ItemEntityRenderer.renderFlatAABB(AABB.getTemporaryBB((float) xRenderOffs - f, (float) yRenderOffs - f, (float) zRenderOffs - f, (float)(xRenderOffs + sizeX) + f, (float)(yRenderOffs + sizeY) + f, (float)(zRenderOffs + sizeZ) + f));
+            GL11.glEndList();
+            setDirty();
+        }
+    }
+    
+    public abstract void rebuild();
+    
+    public boolean renderBlock(Tessellator tessellator, RenderBlocks renderBlocks, Block block, int x, int y, int z) {
+    	boolean rendered = false;
+		final BlockModel<?> model = BlockModelDispatcher.getInstance().getDispatch(block);
+		rendered |= model.render(tessellator, x, y, z);
+		if(model.hasOverbright()) {
+			renderBlocks.overbright = true;
+			rendered |= model.render(tessellator, x, y, z);
+			renderBlocks.overbright = false;
+		}
+		return rendered;
+    }
+
+    protected void translateToPos()
+    {
+        GL11.glTranslatef(xRenderOffs, yRenderOffs, zRenderOffs);
+    }
+
+    public float distanceToEntitySquared(Entity entity)
+    {
+        float dx = (float)(entity.x - (double) xm);
+        float dy = (float)(entity.y - (double) ym);
+        float dz = (float)(entity.z - (double) zm);
+        return dx * dx + dy * dy + dz * dz;
+    }
+
+    public float distanceToCameraSquared(ICamera camera)
+    {
+        float dx = (float)(camera.getX(1f) - xm);
+        float dy = (float)(camera.getY(1f) - ym);
+        float dz = (float)(camera.getZ(1f) - zm);
+        return dx * dx + dy * dy + dz * dz;
+    }
+
+    public void reset()
+    {
+        for(int i = 0; i < MAX_RENDER_PASSES; i++)
+        {
+            empty[i] = true;
+        }
+
+        visible = false;
+        compiled = false;
+    }
+
+    public void delete()
+    {
+        reset();
+        world = null;
+    }
+
+    public int getList(int layer)
+    {
+        if(!visible)
+        {
+            return -1;
+        }
+        if(!empty[layer])
+        {
+            return lists + layer;
+        } 
+        else
+        {
+            return -1;
+        }
+    }
+
+    public void cull(CameraFrustum frustum, float partialTick)
+    {
+        visible = frustum.isVisible(bb, partialTick);
+    }
+
+    public void renderBB()
+    {
+        GL11.glCallList(lists + MAX_RENDER_PASSES);
+    }
+
+    public boolean isEmpty()
+    {
+        if(!compiled)
+        {
+            return false;
+        } else
+        {
+            return empty[0] && empty[1];
+        }
+    }
+
+    public void setDirty()
+    {
+        dirty = true;
+    }
+}
